## com.sun.jersey.core.provider.jaxb
Class AbstractJAXBElementProvider

    java.lang.Object
      com.sun.jersey.core.provider.AbstractMessageReaderWriterProvider<T>
          com.sun.jersey.core.provider.jaxb.AbstractJAXBProvider<javax.xml.bind.JAXBElement<?>>
              com.sun.jersey.core.provider.jaxb.AbstractJAXBElementProvider

All Implemented Interfaces:
  MessageBodyReader<javax.xml.bind.JAXBElement<?>>, MessageBodyWriter<javax.xml.bind.JAXBElement<?>>

    public abstract class AbstractJAXBElementProvider

extends AbstractJAXBProvider<javax.xml.bind.JAXBElement<?>>

An abstract provider for `JAXBElement`.

Implementing classes may extend this class to provide specific marshalling and unmarshalling behaviour.

When unmarshalling a `UnmarshalException` will result in a `WebApplicationException` being thrown with a status of 400 (Client error), and a `JAXBException` will result in a `WebApplicationException` being thrown with a status of 500 (Internal Server error).

When marshalling a `JAXBException` will result in a `WebApplicationException` being thrown with a status of 500 (Internal Server error).

Author:
  Paul.Sandoz@Sun.Com

Field Summary

Fields inherited from class com.sun.jersey.core.provider.AbstractMessageReaderWriterProvider
`UTF8`

Constructor Summary
`AbstractJAXBElementProvider(Providers ps)`
`AbstractJAXBElementProvider(Providers ps, MediaType mt)`

Method Summary
`boolean` | `isReadable(java.lang.Class<?> type, java.lang.reflect.Type genericType, java.lang.annotation.Annotation[] annotations, MediaType mediaType)` Ascertain if the MessageBodyReader can produce an instance of a particular type.
`boolean` | `isWriteable(java.lang.Class<?> type, java.lang.reflect.Type genericType, java.lang.annotation.Annotation[] annotations, MediaType mediaType)` Ascertain if the MessageBodyWriter supports a particular type.
`protected abstract javax.xml.bind.JAXBElement<?>` | `readFrom(java.lang.Class<?> type, MediaType mediaType, javax.xml.bind.Unmarshaller u, java.io.InputStream entityStream)`
`javax.xml.bind.JAXBElement<?>` | `readFrom(java.lang.Class<javax.xml.bind.JAXBElement<?>> type, java.lang.reflect.Type genericType, java.lang.annotation.Annotation[] annotations, MediaType mediaType, MultivaluedMap<java.lang.String,java.lang.String> httpHeaders, java.io.InputStream entityStream)` Read a type from the `InputStream`.
`void` | `writeTo(javax.xml.bind.JAXBElement<?> t, java.lang.Class<?> type, java.lang.reflect.Type genericType, java.lang.annotation.Annotation[] annotations, MediaType mediaType, MultivaluedMap<java.lang.String,java.lang.Object> httpHeaders, java.io.OutputStream entityStream)` Write a type to an HTTP response.
`protected abstract void` | `writeTo(javax.xml.bind.JAXBElement<?> t, MediaType mediaType, java.nio.charset.Charset c, javax.xml.bind.Marshaller m, java.io.OutputStream entityStream)`

Methods inherited from class com.sun.jersey.core.provider.jaxb.AbstractJAXBProvider
`getJAXBContext, getMarshaller, getSAXSource, getStoredJAXBContext, getUnmarshaller, isFormattedOutput, isSupported, isXmlRootElementProcessing, setConfiguration, setHeader`

Methods inherited from class com.sun.jersey.core.provider.AbstractMessageReaderWriterProvider
`getCharset, getSize, readFromAsString, writeTo, writeTo, writeToAsString`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### AbstractJAXBElementProvider

    public AbstractJAXBElementProvider(Providers ps)

### AbstractJAXBElementProvider

    public AbstractJAXBElementProvider(Providers ps,
                                       MediaType mt)

Method Detail

### isReadable

    public boolean isReadable(java.lang.Class<?> type,
                              java.lang.reflect.Type genericType,
                              java.lang.annotation.Annotation[] annotations,
                              MediaType mediaType)

  Description copied from interface: `MessageBodyReader`
  Ascertain if the MessageBodyReader can produce an instance of a particular type. The type parameter gives the class of the object that should be produced, the genericType parameter gives the java.lang.reflect.Type of the object that should be produced. E.g. if the object to be produced is List<String>, the type parameter will be java.util.List and the genericType parameter will be java.lang.reflect.ParameterizedType.

  Parameters:
    `type` - the class of object to be produced.
    `genericType` - the type of object to be produced. E.g. if the message body is to be converted into a method parameter, this will be the formal type of the method parameter as returned by `Method.getGenericParameterTypes`.
    `annotations` - an array of the annotations on the declaration of the artifact that will be initialized with the produced instance. E.g. if the message body is to be converted into a method parameter, this will be the annotations on that parameter returned by `Method.getParameterAnnotations`.
    `mediaType` - the media type of the HTTP entity, if one is not specified in the request then `application/octet-stream` is used.
  Returns:
    true if the type is supported, otherwise false.

### isWriteable

    public boolean isWriteable(java.lang.Class<?> type,
                               java.lang.reflect.Type genericType,
                               java.lang.annotation.Annotation[] annotations,
                               MediaType mediaType)

  Description copied from interface: `MessageBodyWriter`
  Ascertain if the MessageBodyWriter supports a particular type.

  Parameters:
    `type` - the class of object that is to be written.
    `genericType` - the type of object to be written, obtained either by reflection of a resource method return type or via inspection of the returned instance. `GenericEntity` provides a way to specify this information at runtime.
    `annotations` - an array of the annotations on the resource method that returns the object.
    `mediaType` - the media type of the HTTP entity.
  Returns:
    true if the type is supported, otherwise false.

### readFrom

    public final javax.xml.bind.JAXBElement<?> readFrom(java.lang.Class<javax.xml.bind.JAXBElement<?>> type,
                                                        java.lang.reflect.Type genericType,
                                                        java.lang.annotation.Annotation[] annotations,
                                                        MediaType mediaType,
                                                        MultivaluedMap<java.lang.String,java.lang.String> httpHeaders,
                                                        java.io.InputStream entityStream)
                                                 throws java.io.IOException

  Description copied from interface: `MessageBodyReader`
  Read a type from the `InputStream`.

  Parameters:
    `type` - the type that is to be read from the entity stream.
    `genericType` - the type of object to be produced. E.g. if the message body is to be converted into a method parameter, this will be the formal type of the method parameter as returned by `Method.getGenericParameterTypes`.
    `annotations` - an array of the annotations on the declaration of the artifact that will be initialized with the produced instance. E.g. if the message body is to be converted into a method parameter, this will be the annotations on that parameter returned by `Method.getParameterAnnotations`.
    `mediaType` - the media type of the HTTP entity.
    `httpHeaders` - the read-only HTTP headers associated with HTTP entity.
    `entityStream` - the `InputStream` of the HTTP entity. The caller is responsible for ensuring that the input stream ends when the entity has been consumed. The implementation should not close the input stream.
  Returns:
    the type that was read from the stream.
  Throws:
    `java.io.IOException` - if an IO error arises

### readFrom

    protected abstract javax.xml.bind.JAXBElement<?> readFrom(java.lang.Class<?> type,
                                                              MediaType mediaType,
                                                              javax.xml.bind.Unmarshaller u,
                                                              java.io.InputStream entityStream)
                                                       throws javax.xml.bind.JAXBException

  Throws:
    `javax.xml.bind.JAXBException`

### writeTo

    public final void writeTo(javax.xml.bind.JAXBElement<?> t,
                              java.lang.Class<?> type,
                              java.lang.reflect.Type genericType,
                              java.lang.annotation.Annotation[] annotations,
                              MediaType mediaType,
                              MultivaluedMap<java.lang.String,java.lang.Object> httpHeaders,
                              java.io.OutputStream entityStream)
                       throws java.io.IOException

  Description copied from interface: `MessageBodyWriter`
  Write a type to an HTTP response. The response header map is mutable but any changes must be made before writing to the output stream since the headers will be flushed prior to writing the response body.

  Parameters:
    `t` - the instance to write.
    `type` - the class of object that is to be written.
    `genericType` - the type of object to be written, obtained either by reflection of a resource method return type or by inspection of the returned instance. `GenericEntity` provides a way to specify this information at runtime.
    `annotations` - an array of the annotations on the resource method that returns the object.
    `mediaType` - the media type of the HTTP entity.
    `httpHeaders` - a mutable map of the HTTP response headers.
    `entityStream` - the `OutputStream` for the HTTP entity. The implementation should not close the output stream.
  Throws:
    `java.io.IOException` - if an IO error arises

### writeTo

    protected abstract void writeTo(javax.xml.bind.JAXBElement<?> t,
                                    MediaType mediaType,
                                    java.nio.charset.Charset c,
                                    javax.xml.bind.Marshaller m,
                                    java.io.OutputStream entityStream)
                             throws javax.xml.bind.JAXBException

  Throws:
    `javax.xml.bind.JAXBException`

Copyright © 2017 Oracle Corporation. All Rights Reserved.